<?php
/**
 * Mini-component core file
 * @author Vince Wooll <sales@jomres.net>
 * @version Jomres 4
* @package Jomres
* @subpackage mini-components
* @copyright	2005-2009 Vince Wooll

Jomres is distributed as a mix of two licenses (excepting other files in the libraries folder, which are independantly licensed). 

The first, proprietary license, refers to Jomres as a package. You cannot share it, period. You can see the full license here http://www.jomres.net/license.html. There are some exceptions, and these files are independantly licensed (see the /jomres/libraries/phptools folder for example)
The files in the /jomres/core-minicomponents,  /jomres/libraries/jomres/cms_specific and the /jomres/templates folders, whilst copyright Vince Wooll, are licensed differently to allow those users who wish, to develop and distribute their own third party plugins for Jomres. Those files are licensed under the MIT license, which allows third party vendors to modify them to suit their own requirements and if so desired, distribute them for free or cost. 

################################################################
This file is subject to The MIT License. For licencing information, please visit 
http://www.jomres.net/index.php?option=com_content&task=view&id=214&Itemid=86 and http://www.jomres.net/license.html
################################################################
*/

// ################################################################
defined( '_JOMRES_INITCHECK' ) or die( 'Direct Access to '.__FILE__.' is not allowed.' );
// ################################################################

/**
#
 * xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 #
* @package Jomres
#
 */
class j01050x_geocoder {

	/**
	#
	 * xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	#
	 */
	function j01050x_geocoder($componentArgs=null)
		{
		// Must be in all minicomponents. Minicomponents with templates that can contain editable text should run $this->template_touch() else just return
		$MiniComponents =jomres_getSingleton('mcHandler');
		if ($MiniComponents->template_touch)
			{
			$this->template_touchable=false; return;
			}
		$siteConfig = jomres_getSingleton('jomres_config_site_singleton');
		$jrConfig=$siteConfig->get();
		$property_uid=(int)$componentArgs['property_uid'];
		$output=array();
		$pageoutput=array();
		$b = new browser();
		$output['VAR']="";
		if ($b->BROWSER_AGENT=="IE")
			$output['VAR']="var";
			
		if (strlen($jrConfig['google_maps_api_key'])>0)
			{
			$query="SELECT property_name,property_street,property_town,property_postcode,property_tel,property_country,property_region,`lat`,`long` FROM #__jomres_propertys WHERE propertys_uid = '".(int)$property_uid."' LIMIT 1";
			$propertyData=doSelectSql($query,2);
			$output['LAT']=	$propertyData['lat'];
			$output['LONG']=	$propertyData['long'];
			$output['APIKEY']=$jrConfig['google_maps_api_key'];
			if ( $output['LAT'] == 0.00 || strlen( $output['LAT'] ) ==0 || $output['LONG'] == 0.00 || strlen( $output['LONG'] ) ==0  ) // No lat or long details stored, we'll try to find the property via the address
				{
				$propertyData=doSelectSql($query,2);

				$output['ADDRESS']=
					$propertyData['property_street']." ".$propertyData['property_town']." ".
					$propertyData['property_region']." ".$propertyData['property_country'];

				$pageoutput[]=$output;
				$tmpl = new patTemplate();
				$tmpl->setRoot( JOMRES_TEMPLATEPATH_FRONTEND );
				$tmpl->readTemplatesFromInput( 'geocoder.html' );
				$tmpl->addRows( 'pageoutput', $pageoutput );
				if ($jrConfig['composite_property_details']!="1")
					$tmpl->displayParsedTemplate();
				else
					$this->retVals=$tmpl->getParsedTemplate();
				}
			else
				{
				$pageoutput[]=$output;
				$tmpl = new patTemplate();
				$tmpl->setRoot( JOMRES_TEMPLATEPATH_FRONTEND );
				$tmpl->readTemplatesFromInput( 'geocoder_latlong.html' );
				$tmpl->addRows( 'pageoutput', $pageoutput );
				if ($jrConfig['composite_property_details']!="1")
					$tmpl->displayParsedTemplate();
				else
					$this->retVals=$tmpl->getParsedTemplate();
				}
			}
		}



	/**
	#
	 * Must be included in every mini-component
	#
	 * Returns any settings the the mini-component wants to send back to the calling script. In addition to being returned to the calling script they are put into an array in the mcHandler object as eg. $mcHandler->miniComponentData[$ePoint][$eName]
	#
	 */
	// This must be included in every Event/Mini-component
	function getRetVals()
		{
		return $this->retVals;
		}
	}
?>